.nolist
include \masm32\include\masm32rt.inc
; include \masm32\MasmBasic\MasmBasic.inc 
.686
include \masm32\macros\timers.asm
LOOP_COUNT	= 100000

parseFewJumps	PROTO: DWORD
parseTable	PROTO: DWORD
parseTableS	PROTO: DWORD
parseManyJumps	PROTO: DWORD
parseManyAhAl	PROTO: DWORD
parseElseif	PROTO: DWORD
parseSwitch	PROTO: DWORD
parseDave	PROTO: DWORD
ShowCpu	PROTO:DWORD

results MACRO algo
LOCAL tmp$
	tmp$ CATSTR <print str$(eax), 9, "cycles for >, <algo>, <, ">
	tmp$
	@CatStr(<mov eax, >, <algo>, <_endp>)
	@CatStr(<sub eax, >, <algo>)
	ifidn <algo>, <parseTable>
		add eax, ptEnd-pt+1
	elseifidn <algo>, <parseTableS>
		add eax, ptEndS-ptS+1
	elseifidn <algo>, <parseDave>
		add eax, ptEndS-ptS+1			; we treat it as if the standard jumps had been used
		;add eax, Build_T-Build+1
	endif
	print str$(eax), " bytes ", 9, "#h="
	print str$(NumH), ", #dots="
	print str$(NumDots), 13, 10
ENDM

PARSETABLE STRUCT
	TheChar	BYTE ?
	TheLabel	DWORD ?
PARSETABLE ENDS

.data
align 16	; Source string resembles a number format, i.e. contains 22% dots and h characters
Src1	db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
	db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
	db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
	db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h"
	db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h", 0
align 16
Src2	db "1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h1234.5678h", 0
align 16
Src3	db "1234.5678h", 0

.data?
NumH	dd ?
NumDots	dd ?
Dest	db 100 dup(?)

.code
start:
	invoke ShowCpu, 1
	sct = 0
	REPEAT 3
	sct=sct+1
	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseTableS, offset Src>, %sct)
	counter_end
	results parseTableS

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseTable, offset Src>, %sct)
	counter_end
	results parseTable

;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		@CatStr(<invoke parseManyAhAl, offset Src>, %sct)
;	counter_end
;	results parseManyAhAl

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseFewJumps, offset Src>, %sct)
	counter_end
	results parseFewJumps

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseManyJumps, offset Src>, %sct)
	counter_end
	results parseManyJumps

;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		@CatStr(<invoke parseElseif, offset Src>, %sct)
;	counter_end
;	results parseElseif

;	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
;		@CatStr(<invoke parseSwitch, offset Src>, %sct)
;	counter_end
;	results parseSwitch

	counter_begin LOOP_COUNT, HIGH_PRIORITY_CLASS
		@CatStr(<invoke parseDave, offset Src>, %sct)
	counter_end
	results parseDave
	print chr$(13, 10)
	ENDM

	inkey chr$("--- ok ---", 13)
	exit

parseFewJumps proc uses esi Src:DWORD
		and NumH, 0
		and NumDots, 0		; first instruction for all algos
		mov esi, Src
		jmp @F
		HasE:
		jmp @F
		HasDot:
		inc NumDots
		jmp @F
		HasH:
		inc NumH
		jmp @F
		HasB:
		jmp @F
		HasY:
		jmp @F
		HasB1:
		jmp @F
		HasB2:
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; few jumps
				test al, al
				je @F
				or al, 20h
				cmp al, "e"
				je HasE
				cmp al, "."
				je HasDot
				cmp al, "h"
				je HasH
				cmp al, "b"
				je HasB
				cmp al, "y"
				je HasY
				cmp al, "("
				je HasB1
				cmp al, "("
				je HasB2
			.endif
		jmp @B
		@@:
		ret
parseFewJumps endp
parseFewJumps_endp:

parseTable proc uses esi edi Src:DWORD
		plCTS1:
		.data?
	ChTable	dd 256 dup(?)	; CHARTABLE parser
	.data
	pt PARSETABLE <0, plCTE1>,	; if nullbyte found, jump out of the loop
	<"e", ChkE>, <"E", ChkE>,	; exponent, lowercase or uppercase
	<".", ChkDot>,
	<"h", ChkH>, <"H", ChkH>,	; hex
	<"b", ChkB>, <"B", ChkB>,	; binary
	<"y", ChkY>, <"Y", ChkY>,	; binary
	<"(", ChkB1>, <")", ChkB2>	; brackets
	ptEnd db -128		; flag end of table
		.code
		and NumH, 0		; first instruction for all algos
		and NumDots, 0		; first instruction for all algos
		mov esi, Src
		mov edi, offset ChTable
		cmp dword ptr [edi], 0
		jne plCT0
		mov ecx, 256	; this part will be run only once, so it can be slow
		push edi
		mov eax, plCT	; set defaults
		rep stosd
		pop edi
		push esi
		mov esi, offset pt
		.Repeat
			lodsb
			.Break .if al==-128
			movzx edx, al
			lodsd
			mov [edi+4*edx], eax
		.Until 0
		pop esi
		jmp plCT0

		ChkE:
		jmp plCT
		ChkDot:
		inc NumDots
		jmp plCT
		ChkH:
		inc NumH
		jmp plCT
		ChkB:
		jmp plCT
		ChkY:
		jmp plCT
		ChkB1:
		jmp plCT
		ChkB2:
	plCT0:
		xor eax, eax
	plCT:
		movzx eax, byte ptr [esi]
		inc esi
		; now jump to the address obtained from the table
		if 0
			jmp dword ptr [ChTable+4*eax]		; slowest
		elseif 1
			mov eax, [edi+4*eax]					; fastest
			jmp eax
		else
			jmp dword ptr [edi+4*eax]			; fast
		endif

	plCTE1:
	ret
parseTable endp
parseTable_endp:

parseTableS proc uses esi edi Src:DWORD
		.data?
	ChTableS	dd 256 dup(?)				; character table for parser
		.data
	ptS	db 0, plOut-plBASE				; if nullbyte found, jump out of the loop
		db "e", plChkE-plBASE, "E", plChkE-plBASE	; exponent, lowercase or uppercase
		db ".", plChkDot-plBASE
		db "h", plChkH-plBASE, "H", plChkH-plBASE	; hex
		db "b", plChkB-plBASE, "B", plChkB-plBASE	; binary
		db "y", plChkY-plBASE, "Y", plChkY-plBASE	; binary
		db "(", plChkB1-plBASE, ")", plChkB2-plBASE	; brackets
	ptEndS	db -128					; flag end of table
		.code
		and NumH, 0					; first instructions for all algos:
		and NumDots, 0				; reset the test counters
		mov edi, offset ChTableS
		xor ecx, ecx
		cmp dword ptr [edi], ecx
		jne plSct0						; ---- this part creates the chartable and will be run only once, so it can be slow ----
		inc ch							; xor ecx, ecx + inc ch is one byte shorter than mov ecx, 256
		push edi
		mov eax, plSct				; set defaults to entry of innermost loop
		rep stosd
		pop edi							; edi=offset ChTableS
		mov esi, offset ptS			; parse table specific chars
	if 0
		.While 1
			lodsb
			.Break .if al==-128		; flag we are done
			movzx edx, al				; the character requiring specific action, e.g. "h"
			lodsb
			movzx eax, al				; the byte offset against plBASE
			add eax, plBASE			; translate into a dword address
			mov [edi+4*edx], eax	; store into the table in the .data? section
		.Endw
		repeat 5	; 5 onwards makes it a lot faster
			nop
		endm
		jmp plSct0					; skip action zone and point esi to Src
	else
		.While 1
			lodsb
			cmp al, -128				; flag we are done
			je plSct0					; skip action zone and point esi to Src
			; .Break .if al==-128		; flag we are done
			movzx edx, al				; the character requiring specific action, e.g. "h"
			lodsb
			movzx eax, al				; the byte offset against plBASE
			add eax, plBASE			; translate into a dword address
			mov [edi+4*edx], eax	; store into the table in the .data? section
		.Endw
		; jmp plSct0					; skip action zone and point esi to Src
	endif

plBASE:	; ----------------------- here is the action zone for some specific chars -----------------------
		plChkE:				; e: maybe an exponent, maybe a hex char, who knows?
		jmp plSct
		plChkDot:
		inc NumDots		; a dot: it's a float
		jmp plSct
		plChkH:
		inc NumH			; h: end of a Hex$
		jmp plSct
		plChkB:				; b: maybe the end of a Bin$, maybe a hex char, who knows?
		jmp plSct
		plChkY:				; y: surely the end of a Bin$
		jmp plSct
		plChkB1:			; (: we have brackets, e.g. (1234h)
		jmp plSct
		plChkB2:			; ): end of a bracketed string
		nop

plSct0:	mov esi, Src		; let's go
		; ----------- innermost loop ----------------------------------------
plSct:	movzx eax, byte ptr [esi]			; load the char from the source string
		inc esi
		jmp dword ptr [edi+4*eax]		; jump to the address obtained from the table
		; ----------- end of innermost loop ------------------------------
	plOut:
	ret
parseTableS endp
parseTableS_endp:

parseManyJumps proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		and NumDots, 0		; first instruction for all algos
		mov esi, Src
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					inc NumDots
					jmp @B
				.endif
				.if al=="h"
					inc NumH
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al==")"
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		ret
parseManyJumps endp
parseManyJumps_endp:

parseManyAhAl proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		and NumDots, 0		; first instruction for all algos
		mov esi, Src
		@@:
			movzx eax, word ptr [esi]
			inc esi
			.if al>="0" && al<="9"
				mov al, ah
				inc esi
			.endif
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.endif
				.if al=="."
					inc NumDots
					jmp @B
				.endif
				.if al=="h"
					inc NumH
					jmp @B
				.endif
				.if al=="b"
					jmp @B
				.endif
				.if al=="y"
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
				.if al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		ret
parseManyAhAl endp
parseManyAhAl_endp:

parseElseif proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		and NumDots, 0		; first instruction for all algos
		mov esi, Src
		@@:
			mov al, [esi]
			inc esi
			.if al<"0" || al>"9"	; many jumps
				test al, al
				je @F
				or al, 20h
				.if al=="e"
					jmp @B
				.elseif al=="."
					inc NumDots
					jmp @B
				.elseif al=="h"
					inc NumH
					jmp @B
				.elseif al=="b"
					jmp @B
				.elseif al=="y"
					jmp @B
				.elseif al=="("
					jmp @B
				.elseif al=="("
					jmp @B
				.endif
			.endif
		jmp @B
		@@:
		ret
parseElseif endp
parseElseif_endp:

parseSwitch proc uses esi Src:DWORD
		and NumH, 0		; first instruction for all algos
		and NumDots, 0		; first instruction for all algos
		mov esi, Src
		@@:
			movzx eax, byte ptr [esi]
			inc esi
			.if al<"0" || al>"9"
				or al, 20h
				SWITCH eax
				CASE 20h
				jmp @F
				CASE "e"
				CASE "."
					inc NumDots
				CASE "h"
					inc NumH
				CASE "b"
				CASE "y"
				CASE "("
				CASE ")"
				ENDSW
			.endif
		jmp @B
		@@:
		ret
parseSwitch endp
parseSwitch_endp:

parseDave proc uses esi edi Src:DWORD

.DATA

;class branch vector table

        ALIGN   4

VectTbl dd Class0,Class1,Class2,Class3,Class4

;---------------------------------------

;example test string

TstStr  db '23456kjhio;h-sASDFDS3456#%$$^2453ffSAER35347fds@%#$SF',0

;---------------------------------------

;class-to-vector translation table build command string

;  ASCII           Class          Table value (4 * Class)

;    0               0                 0
;   1-2Fh            4                10h
; 30h-39h            1                 4
; 3Ah-40h            4                10h
; 41h-5Ah            2                 8
; 5Bh-60h            4                10h
; 61h-7Ah            3                0Ch
; 7Bh-FFh            4                10h

;each byte pair = (count,4*Class)

Build   db 1,0          ;ASCII 0       = Class 0
        db 2Fh,10h      ;ASCII 1-2Fh   = Class 4
        db 0Ah,4        ;ASCII 30h-39h = Class 1
        db 7,10h        ;ASCII 3Ah-40h = Class 4
        db 1Ah,8        ;ASCII 41h-5Ah = Class 2
        db 6,10h        ;ASCII 5Bh-60h = Class 4
        db 1Ah,0Ch      ;ASCII 61h-7Ah = Class 3
        db 85h,10h      ;ASCII 7Bh-FFh = Class 4
Build_T db 0            ;count 0 = terminate build

;---------------------------------------

        .DATA?

;---------------------------------------

;byte-size class-to-vector translation table

XlatTbl db 256 dup(?)

;---------------------------------------

;output string buffer

OutBuf  db 64 dup(?)
.code
		and NumH, 0					; first instruction for all algos
		and NumDots, 0				; first instruction for all algos
;		int 3
		mov edi, offset XlatTbl
		cmp dword ptr [edi], 0		; table already built?
		jne ParseTheString

; build the translation table - this code is executed one time during program initialization

;  ASCII           Class          Table value (4 * Class)

;    0               0                 0
;   1-2Fh            4                10h
; 30h-39h            1                 4
; 3Ah-40h            4                10h
; 41h-5Ah            2                 8
; 5Bh-60h            4                10h
; 61h-7Ah            3                0Ch
; 7Bh-FFh            4                10h

        cld
        mov     esi, offset Build
        xor     eax, eax
;        mov     edi,offset XlatTbl set above
        mov     ecx,eax
        jmp short Build_Loop_Entry

Build_Loop:
        xchg    eax,ecx
        lodsb                  ;get the value
        rep     stosb

Build_Loop_Entry:
        lodsb                  ;get the count
        or      al,al
        jnz     Build_Loop

;---------------------------------------

;display the un-parsed test string

;        print   offset TstStr
;        print   chr$(13,10,13,10)

;---------------------------------------

;parse the string

ParseTheString:
	if 0
		mov esi, offset TstStr
		mov edi, offset OutBuf
	else
		mov esi, Src
		mov edi, offset OutBuf
	endif
	jmp short Parse_Loop_Entry

Parse_Loop:
;	mov [edi], al
;	inc edi

Parse_Loop_Entry:
Class4:
	movzx eax, byte ptr [esi]
	inc esi
	if 1
		movzx eax, byte ptr XlatTbl[eax]		; get the "class"
	else
		mov al, byte ptr XlatTbl[eax]			; get the "class"
	endif
	jmp VectTbl[eax]

Class1: mov al,'0'
	inc NumDots		; just for testing, costs some extra cycles to Dave unless the table is adjusted
	jmp Parse_Loop

Class2: mov al,'A'
	jmp Parse_Loop

Class3: mov al,'a'
	inc NumH			; just for testing
	jmp Parse_Loop

Class0: xor eax, eax
	stosb
	ret
parseDave endp
parseDave_endp:

OPTION PROLOGUE:NONE
OPTION EPILOGUE:NONE
ShowCpu proc mode:DWORD
COMMENT	@ Usage: 
Move this line up:
ShowCpu	PROTO:DWORD
	invoke ShowCpu, 0		; simple, no printing, just returns SSE level
	invoke ShowCpu, 1		; prints the brand string and returns SSE level@
  pushad
  sub esp, 80	; create a buffer for the brand string
  mov edi, esp		; point edi to it
  xor ebp, ebp
  .Repeat
  	lea eax, [ebp+80000002h]
	db 0Fh, 0A2h		; cpuid 80000002h-80000004h
	stosd
	mov eax, ebx
	stosd
	mov eax, ecx
	stosd
	mov eax, edx
	stosd
	inc ebp
  .Until ebp>=3
  push 1
  pop eax
  db 0Fh, 0A2h			; cpuid 1
  xor ebx, ebx					; CpuSSE
  xor esi, esi					; add zero plus the carry flag
  bt edx, 25					; edx bit 25, SSE1
  adc ebx, esi
  bt edx, 26					; edx bit 26, SSE2
  adc ebx, esi
  bt ecx, esi					; ecx bit 0, SSE3
  adc ebx, esi
  bt ecx, 9						; ecx bit 9, SSE4
  adc ebx, esi
  dec dword ptr [esp+4+32+80]				; dec mode in stack
  .if Zero?
	mov edi, esp							; restore pointer to brand string
  	.Repeat				
		.Break .if byte ptr [edi]!=32	; mode was 1, so show a string but skip leading blanks
		inc edi
	.Until 0
	print edi								; CpuBrand
	.if ebx
		print chr$(32, 40, "SSE")		; info on SSE level, 40=(
		print str$(ebx), 41, 13, 10		; 41=)
	.endif
  .endif
  add esp, 80				; discard brand buffer (after printing!)
  mov [esp+32-4], ebx		; move ebx into eax stack position - returns eax to main for further use
  popad
  ret 4
ShowCpu endp
OPTION PROLOGUE:PrologueDef
OPTION EPILOGUE:EpilogueDef

end start
[url=\masm32\RichMasm\XorSubMov0_cyct.asc]Last file with cyct macros[/url]

		if 0
			jmp dword ptr [ChTableS+4*eax]		; slowest
		elseif 0
			mov eax, [edi+4*eax]					; fast
			jmp eax
		else
			jmp dword ptr [edi+4*eax]			; fastest on P4
		endif

RichMasm options:

OPT_Tmp2Asm	1
OPT_Assembler	ml
OPT_Wait	0

Check also the [url=\masm32\RichMasm\RES\TimingsMacro.asc]timings macro[/url]
